Package org.wildfly.plugin.provision

## Class PackageServerMojo

- java.lang.Object
- - org.apache.maven.plugin.AbstractMojo
  - - org.wildfly.plugin.provision.PackageServerMojo

- All Implemented Interfaces:
    `org.apache.maven.plugin.ContextEnabled`, `org.apache.maven.plugin.Mojo`
  Direct Known Subclasses:
    `ApplicationImageMojo`

      @Mojo(name="package",
            requiresDependencyResolution=COMPILE_PLUS_RUNTIME,
            defaultPhase=PACKAGE)
      public class PackageServerMojo
      extends org.apache.maven.plugin.AbstractMojo

  Provision a server, copy extra content and deploy primary artifact if it exists
  Since:
    3.0
  Author:
    jfdenise

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected org.jboss.galleon.universe.maven.repo.MavenRepoManager` | `artifactResolver` |
    `static String` | `BOOTABLE_JAR_NAME_RADICAL` | Deprecated, for removal: This API element is subject to removal in a future version.
    `static String` | `JAR` | Deprecated, for removal: This API element is subject to removal in a future version.
    `protected String` | `provisioningDir` | The path to the directory where to provision the server.
    `protected String` | `runtimeName` | Deprecated. use the `name` property instead to change the name of the deployment.
    `protected boolean` | `skipDeployment` | Skip deploying the deployment after the server is provisioned (`false` by default).

    - ### Fields inherited from interface org.apache.maven.plugin.Mojo

      `ROLE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PackageServerMojo()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected org.jboss.galleon.api.config.GalleonProvisioningConfig` | `buildGalleonConfig​(org.jboss.galleon.api.GalleonBuilder pm)` |
    `void` | `copyExtraContent​(Path target)` |
    `protected void` | `enrichRepositories()` |
    `void` | `execute()` |
    `protected org.jboss.galleon.api.config.GalleonProvisioningConfig` | `getDefaultConfig()` |
    `protected Path` | `getDeploymentContent()` |
    `protected String` | `getDeploymentTargetName()` | Return the file name of the deployment to put in the server deployment directory
    `protected String` | `getGoal()` |
    `protected void` | `serverProvisioned​(Path jbossHome)` |

    - ### Methods inherited from class org.apache.maven.plugin.AbstractMojo

      `getLog, getPluginContext, setLog, setPluginContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### JAR

          @Deprecated(forRemoval=true,
                      since="5.1")
          public static final String JAR

      Deprecated, for removal: This API element is subject to removal in a future version.
      See Also:
        Constant Field Values

    - #### BOOTABLE_JAR_NAME_RADICAL

          @Deprecated(forRemoval=true,
                      since="5.1")
          public static final String BOOTABLE_JAR_NAME_RADICAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      See Also:
        Constant Field Values

    - #### runtimeName

          @Deprecated(since="4.1.O")
          @Parameter(property="wildfly.deployment.runtime.name",
                     alias="runtime-name")
          protected String runtimeName

      Deprecated.
      use the `name` property instead to change the name of the deployment.
      The runtime name for the deployment.

      When the deployment is copied to the server, it is renamed with the `runtime-name`. If both `name` and `runtime-name` are specified, `runtime-name` is used.

    - #### skipDeployment

          @Parameter(defaultValue="false",
                     property="wildfly.package.deployment.skip")
          protected boolean skipDeployment

      Skip deploying the deployment after the server is provisioned (`false` by default).

    - #### provisioningDir

          @Parameter(alias="provisioning-dir",
                     property="wildfly.provisioning.dir",
                     defaultValue="server")
          protected String provisioningDir

      The path to the directory where to provision the server. Can be an absolute path or a path relative to the buildDir. By default the server is provisioned into the `target/server` directory.

    - #### artifactResolver

          protected org.jboss.galleon.universe.maven.repo.MavenRepoManager artifactResolver

  - ### Constructor Detail

    - #### PackageServerMojo

          public PackageServerMojo()

  - ### Method Detail

    - #### getDefaultConfig

          protected org.jboss.galleon.api.config.GalleonProvisioningConfig getDefaultConfig()
                                                                                     throws org.jboss.galleon.ProvisioningException

      Throws:
        `org.jboss.galleon.ProvisioningException`

    - #### buildGalleonConfig

          protected org.jboss.galleon.api.config.GalleonProvisioningConfig buildGalleonConfig​(org.jboss.galleon.api.GalleonBuilder pm)
                                                                                       throws org.apache.maven.plugin.MojoExecutionException,
                                                                                              org.jboss.galleon.ProvisioningException

      Throws:
        `org.apache.maven.plugin.MojoExecutionException`
        `org.jboss.galleon.ProvisioningException`

    - #### getGoal

          protected String getGoal()

    - #### execute

          public void execute()
                       throws org.apache.maven.plugin.MojoExecutionException,
                              org.apache.maven.plugin.MojoFailureException

      Specified by:
        `execute` in interface `org.apache.maven.plugin.Mojo`
      Throws:
        `org.apache.maven.plugin.MojoExecutionException`
        `org.apache.maven.plugin.MojoFailureException`

    - #### serverProvisioned

          protected void serverProvisioned​(Path jbossHome)
                                    throws org.apache.maven.plugin.MojoExecutionException,
                                           org.apache.maven.plugin.MojoFailureException

      Throws:
        `org.apache.maven.plugin.MojoExecutionException`
        `org.apache.maven.plugin.MojoFailureException`

    - #### getDeploymentTargetName

          protected String getDeploymentTargetName()
                                            throws org.apache.maven.plugin.MojoExecutionException

      Return the file name of the deployment to put in the server deployment directory
      Throws:
        `org.apache.maven.plugin.MojoExecutionException`

    - #### copyExtraContent

          public void copyExtraContent​(Path target)
                                throws org.apache.maven.plugin.MojoExecutionException,
                                       IOException

      Throws:
        `org.apache.maven.plugin.MojoExecutionException`
        `IOException`

    - #### getDeploymentContent

          protected Path getDeploymentContent()
                                       throws org.apache.maven.plugin.MojoExecutionException

      Throws:
        `org.apache.maven.plugin.MojoExecutionException`

    - #### enrichRepositories

          protected void enrichRepositories()
                                     throws org.apache.maven.plugin.MojoExecutionException

      Throws:
        `org.apache.maven.plugin.MojoExecutionException`